#pragma once

class myIDirectInput8: public IDirectInput8
{
public:
    myIDirectInput8(IDirectInput8 *pOriginal);
    virtual ~myIDirectInput8(void);
	
	HRESULT  __stdcall QueryInterface(REFIID riid, LPVOID * ppvObj);
    ULONG    __stdcall AddRef(void);
    ULONG    __stdcall Release(void);

    HRESULT  __stdcall CreateDevice(REFGUID,LPDIRECTINPUTDEVICE8W *,LPUNKNOWN);
    HRESULT  __stdcall EnumDevices(DWORD,LPDIENUMDEVICESCALLBACKW,LPVOID,DWORD);
    HRESULT  __stdcall GetDeviceStatus(REFGUID);
    HRESULT  __stdcall RunControlPanel(HWND,DWORD);
    HRESULT  __stdcall Initialize(HINSTANCE,DWORD);
    HRESULT  __stdcall FindDevice(REFGUID,LPCWSTR,LPGUID);
    HRESULT  __stdcall EnumDevicesBySemantics(LPCWSTR,LPDIACTIONFORMATW,LPDIENUMDEVICESBYSEMANTICSCBW,LPVOID,DWORD);
    HRESULT  __stdcall ConfigureDevices(LPDICONFIGUREDEVICESCALLBACK,LPDICONFIGUREDEVICESPARAMSW,DWORD,LPVOID);

private:
    IDirectInput8 *m_pIDirectInput8;
};

class myIDirectInputDevice8: public IDirectInputDevice8
{
public:
    myIDirectInputDevice8(IDirectInputDevice8 *pOriginal, int iInterfaceNumber);
    virtual ~myIDirectInputDevice8(void);

	HRESULT  __stdcall QueryInterface(REFIID riid, LPVOID * ppvObj);
    ULONG    __stdcall AddRef(void);
    ULONG    __stdcall Release(void);
    
    HRESULT  __stdcall GetCapabilities(LPDIDEVCAPS);
    HRESULT  __stdcall EnumObjects(LPDIENUMDEVICEOBJECTSCALLBACKW,LPVOID,DWORD);
    HRESULT  __stdcall GetProperty(REFGUID,LPDIPROPHEADER);
    HRESULT  __stdcall SetProperty(REFGUID,LPCDIPROPHEADER);
    HRESULT  __stdcall Acquire(void);
    HRESULT  __stdcall Unacquire(void);
    HRESULT  __stdcall GetDeviceState(DWORD,LPVOID);
    HRESULT  __stdcall GetDeviceData(DWORD,LPDIDEVICEOBJECTDATA,LPDWORD,DWORD);
    HRESULT  __stdcall SetDataFormat(LPCDIDATAFORMAT);
    HRESULT  __stdcall SetEventNotification(HANDLE);
    HRESULT  __stdcall SetCooperativeLevel(HWND,DWORD);
    HRESULT  __stdcall GetObjectInfo(LPDIDEVICEOBJECTINSTANCEW,DWORD,DWORD);
    HRESULT  __stdcall GetDeviceInfo(LPDIDEVICEINSTANCEW);
    HRESULT  __stdcall RunControlPanel(HWND,DWORD);
    HRESULT  __stdcall Initialize(HINSTANCE,DWORD,REFGUID);
	
	HRESULT  __stdcall CreateEffect(REFGUID,LPCDIEFFECT,LPDIRECTINPUTEFFECT *,LPUNKNOWN);
    HRESULT  __stdcall EnumEffects(LPDIENUMEFFECTSCALLBACKW,LPVOID,DWORD);
    HRESULT  __stdcall GetEffectInfo(LPDIEFFECTINFOW,REFGUID);
    HRESULT  __stdcall GetForceFeedbackState(LPDWORD);
    HRESULT  __stdcall SendForceFeedbackCommand(DWORD);
    HRESULT  __stdcall EnumCreatedEffectObjects(LPDIENUMCREATEDEFFECTOBJECTSCALLBACK,LPVOID,DWORD);
    HRESULT  __stdcall Escape(LPDIEFFESCAPE);
    HRESULT  __stdcall Poll(void);
    HRESULT  __stdcall SendDeviceData(DWORD,LPCDIDEVICEOBJECTDATA,LPDWORD,DWORD);
    HRESULT  __stdcall EnumEffectsInFile(LPCWSTR,LPDIENUMEFFECTSINFILECALLBACK,LPVOID,DWORD);
    HRESULT  __stdcall WriteEffectToFile(LPCWSTR,DWORD,LPDIFILEEFFECT,DWORD);
    HRESULT  __stdcall BuildActionMap(LPDIACTIONFORMATW,LPCWSTR,DWORD);
    HRESULT  __stdcall SetActionMap(LPDIACTIONFORMATW,LPCWSTR,DWORD);
    HRESULT  __stdcall GetImageInfo(LPDIDEVICEIMAGEINFOHEADERW);

private:
    IDirectInputDevice8 *m_pIDirectInputDevice8;
	int                  m_iInterfaceNumber;
};

class myIDirectInputEffect: public IDirectInputEffect
{
public:
    myIDirectInputEffect(IDirectInputEffect *pOriginal);
    virtual ~myIDirectInputEffect(void);
	
	HRESULT  __stdcall QueryInterface(REFIID riid, LPVOID * ppvObj);
    ULONG    __stdcall AddRef(void);
    ULONG    __stdcall Release(void);

    HRESULT  __stdcall Initialize(HINSTANCE,DWORD,REFGUID);
    HRESULT  __stdcall GetEffectGuid(LPGUID);
    HRESULT  __stdcall GetParameters(LPDIEFFECT,DWORD);
    HRESULT  __stdcall SetParameters(LPCDIEFFECT,DWORD);
    HRESULT  __stdcall Start(DWORD,DWORD);
    HRESULT  __stdcall Stop(void);
    HRESULT  __stdcall GetEffectStatus(LPDWORD);
    HRESULT  __stdcall Download(void);
    HRESULT  __stdcall Unload(void);
    HRESULT  __stdcall Escape(LPDIEFFESCAPE);

private:
    IDirectInputEffect *m_pIDirectInputEffect;
};
 
//WINMMAPI MMRESULT WINAPI joyConfigChanged( DWORD dwFlags );
//void WINAPI ShowJoyCPL( HWND hWnd );
